# file: hexTessellate.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# This file contains python (2.7) code for tessellating with hexagons.
#
from stddraw import *

SIDE = .08

def start():
    def responder(event):
        hexTessellate(picture, SIDE)

    picture = Picture()
    picture.setW(800)
    picture.setH(800)
    picture.bind("<Button-1>", responder)
    picture.start()

def hexagon(picture, x, y, side, color):

    h = side / 2.0
    
    x1, y1 = (x + side, y)
    x2, y2 = (x + h, y + side)
    x3, y3 = (x - h, y + side)
    x4, y4 = (x - side, y)
    x5, y5 = (x - h, y - side)
    x6, y6 = (x + h, y - side)

    xs = [x1, x2, x3, x4, x5, x6]
    ys = [y1, y2, y3, y4, y5, y6]

    picture.filledPolygon(xs, ys, color)
    picture.polygon(xs, ys)

def hexTessellateRow(picture, y, side, evenRow):

    def repeat(x):
        if x < 1.0:
            color = picture.randomColor()
            hexagon(picture, x, y, side, color)
            repeat(x + side * 3)
            
    repeat(0) if evenRow else repeat(1.5 * side)
    
def hexTessellate(picture, side):
    def repeat(y, evenRow):
        if y + side > 0:
            hexTessellateRow(picture, y, side, evenRow)
            repeat(y - side, not(evenRow))

    repeat(1.0, True)

start()
