# file: part1.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Solution to part1 of problem set 3.
#

# Helpers
#
def isFactor(m, n): return n % m == 0

def fact(n):
    if n == 0:
        return 1
    else:
        return n * fact(n - 1)


# discount : int -> float
#
# The call discount(age) returns a percentage discount depending
# on the age. Kids (under age 13) get in free (i.e., a 100% discount),
# people otherwise under the age of 25, but not 19 year olds, receive
# a 20% discount, seniors >= 65 receive a 30% discount. Otherwise 
# your discount is 0%.
#
def discount(age):
    if age < 13:
        return 1.0
    elif age < 25 and (not (age == 19)):
        return 0.2
    elif age > 64:
        return 0.3
    else:
        return 0.0

# euler : int -> float
#
# The call (euler n) returns the nth approximation of Euler's number
#
# e = 2.718281 ...
#
def euler(n):
    if n == 0:
        return 1.0
    else:
        previous = euler(n - 1)
        return previous + (1.0 / fact(n))


# firstFactor : int -> int
#
# The call (firstFactor n) returns the smallest integer factor of
# n that is greater than 1.
#
def firstFactor(n):
    def repeat(m):
        if isFactor(m, n):
            return m
        else:
            return repeat(m + 1)
    return repeat(2)


# isPerfect : int -> bool
#
# The call (isPerfect n) returns true if n is a perfect number and
# false otherwise. A number is perfect if it is equal to the sum of
# it's proper factors. E.g., 6 is perfect because 6 = 3 + 2 + 1.
#
def isPerfect(n):
    def repeat(m, sum):
        if m > n / 2:
            return sum == n
        elif isFactor(m, n):
            return repeat(m + 1, sum + m)
        else:
            return repeat(m + 1, sum)
    return repeat(1, 0)
