# file: ring.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Python code for rendering a ring.

from stddraw import *
import random

def start():
    def responder(event):
        ring(picture, .5, .5, .3, .2, 'green')

    picture = Picture()
    picture.setH(800)
    picture.setW(800)
    picture.bind('<Button-1>', responder)
    picture.start()

# ring : Picture * float * float * float * float * color -> void
#
# The call ring(pict, x, y, radius, width, color) draws 
# a ring in picture centered at (x, y), with radius radius and
# the specified color.
#
def ring(picture, x, y, radius, width, color):
    picture.filledCircle(x, y, radius, color)
    picture.filledCircle(x, y, radius - width, 'white')


