# file: rings.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Python code for rendering a tessellation of rings.

from stddraw import *
import rowOfRings

def start():
    def responder(event):
        rings(picture, 7)

    picture = Picture()
    picture.setH(800)
    picture.setW(800)
    picture.bind('<Button-1>', responder)
    picture.start()

# rings : Picture * int -> void
#
# The call rings(picture, N) draws an N x N grid of rings of diameter 1.0 / N.
#
def rings(picture, N):
    radius = 1.0 / N / 2.0
    def repeat(i):
        if i < N:
            y = (2 * i + 1) * radius
            rowOfRings.rowOfRings(picture, y, N)
            repeat(i + 1)
    repeat(0)

start()
