# file: rowOfRings.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# Python code for rendering a row of rings.

from stddraw import *
import random
import ring

def start():
    def responder(event):
        rowOfRings(picture, .5, 4)

    picture = Picture()
    picture.setH(800)
    picture.setW(800)
    picture.bind('<Button-1>', responder)
    picture.start()

# rowOfRings : Picture * float * float * int -> void
#
# The call rowOfRings(picture, radius, y, N) draws a single row of N rings
# of radius radius centered at y.
#
def rowOfRings(picture, y, N):
    radius = 1.0 / N / 2
    def loop(i):
        if i < N:
            x = (2 * i + 1) * radius
            width = radius * random.random()
            color = picture.randomColor()
            ring.ring(picture, x, y, radius, width, color)
            loop(i + 1)
    loop(0)
